# shells

Get a list of all unix shells for which user configuration files exist.
Supports bash, zsh, and fish.

## Installation

```sh
npm install shells --save
```

## Usage

```js
const shells = require('shells')()
```

This module looks for the following files in your home directory:

```
~/.bashrc
~/.bash_profile
~/.config/fish/config.fish
~/.zshrc
```

It returns an array of the extant files, sorted by most recently modified:

```js
[{
  file: '/Users/zeke/.zshrc',
  type: 'zsh'
}, {
  file: '/Users/zeke/.bashrc',
  type: 'bash'
}]
```

The first one on the list is _probably_ the user's preferred shell, but
there's no guarantee. If you just want to know the user's _current_ shell, use `process.env.SHELL`, but be aware this [isn't always accurate](http://stackoverflow.com/questions/32165525/get-the-current-shell-using-node-js).

## Tests

```sh
npm install
npm test
```

## Dependencies

- [path-exists](https://github.com/sindresorhus/path-exists): Check if a path exists

## Dev Dependencies

- [standard](https://github.com/feross/standard): JavaScript Standard Style
- [tap-spec](https://github.com/scottcorgan/tap-spec): Formatted TAP output like Mocha&#39;s spec reporter
- [tape](https://github.com/substack/tape): tap-producing test harness for node and browsers

## License

MIT

_Generated by [package-json-to-readme](https://github.com/zeke/package-json-to-readme)_
